<html>
<head>
<title>OGRE: OgrePose.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePose.h</h1><a href="OgrePose_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2005 The OGRE Team</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OGRE_POSE_H</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_POSE_H</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00049"></a><a class="code" href="classOgre_1_1Pose.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00057"></a>00057         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00058"></a>00058         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>();
<a name="l00060"></a><a class="code" href="classOgre_1_1Pose.html#73c497f062296a446298258d3b500e86">00060</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00062"></a><a class="code" href="classOgre_1_1Pose.html#8c18792868f8165a19ef645b9395a20b">00062</a>         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getTarget(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTarget; }
<a name="l00064"></a><a class="code" href="classOgre_1_1Pose.html#5dd51aff1599c910c91862a5c08e90b2">00064</a>         <span class="keyword">typedef</span> std::map&lt;size_t, Vector3&gt; VertexOffsetMap;
<a name="l00066"></a><a class="code" href="classOgre_1_1Pose.html#ab53719cd5a035c0b5ca9301c9927a9a">00066</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;VertexOffsetMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">VertexOffsetIterator</a>;
<a name="l00068"></a><a class="code" href="classOgre_1_1Pose.html#b7830f6ad3feaf3740a8e6477d97cef5">00068</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstMapIterator&lt;VertexOffsetMap&gt;</a> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstVertexOffsetIterator</a>;
<a name="l00069"></a>00069 
<a name="l00074"></a>00074         <span class="keywordtype">void</span> addVertex(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; offset);
<a name="l00075"></a>00075 
<a name="l00077"></a>00077         <span class="keywordtype">void</span> removeVertex(<span class="keywordtype">size_t</span> index);
<a name="l00078"></a>00078 
<a name="l00080"></a>00080         <span class="keywordtype">void</span> clearVertexOffsets(<span class="keywordtype">void</span>);
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstVertexOffsetIterator</a> getVertexOffsetIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00085"></a>00085         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">VertexOffsetIterator</a> getVertexOffsetIterator(<span class="keywordtype">void</span>);
<a name="l00087"></a><a class="code" href="classOgre_1_1Pose.html#7216f1dac1bd9e0bec03160d2929248a">00087</a>         <span class="keyword">const</span> VertexOffsetMap&amp; getVertexOffsets(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexOffsetMap; }
<a name="l00088"></a>00088 
<a name="l00090"></a>00090         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; _getHardwareVertexBuffer(<span class="keywordtype">size_t</span> numVertices) <span class="keyword">const</span>;
<a name="l00091"></a>00091 
<a name="l00095"></a>00095         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* clone(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00096"></a>00096     <span class="keyword">protected</span>:
<a name="l00098"></a><a class="code" href="classOgre_1_1Pose.html#f23de51f107e8192583857cf230a574e">00098</a>         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> mTarget;
<a name="l00100"></a><a class="code" href="classOgre_1_1Pose.html#4dfab7ef915235c4e3885054f0649c3e">00100</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName;
<a name="l00102"></a><a class="code" href="classOgre_1_1Pose.html#e0965a04e0b5b5285e29b10e646561a0">00102</a>         VertexOffsetMap mVertexOffsetMap;
<a name="l00104"></a><a class="code" href="classOgre_1_1Pose.html#4256531f55d7093373437ca1864115a5">00104</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> mBuffer;
<a name="l00105"></a>00105     };
<a name="l00106"></a><a class="code" href="namespaceOgre.html#8f03b49c53cbcc1d22f4ef3abfb5b1eb">00106</a>     <span class="keyword">typedef</span> std::vector&lt;Pose*&gt; <a class="code" href="namespaceOgre.html#8f03b49c53cbcc1d22f4ef3abfb5b1eb">PoseList</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
